/* $Id: ssssbox.h 388 2005-04-28 21:04:09Z mwp $ */
/*
THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE AND AGAINST
INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
 * 8->16 Sbox generated by Millan et. al. at Queensland University of
 * Technology. See: E. Dawson, W. Millan, L. Burnett, G. Carter,
 * "On the Design of 8*32 S-boxes". Unpublished report, by the
 * Information Systems Research Centre,
 * Queensland University of Technology, 1999.
 *
 * Used in SSS to generate the key-dependent S-box.
 */
WORD Qbox[256] = {
    0x1887,   0x435c,   0xc042,   0x6ef4,   
    0xee20,   0xfed3,   0xc502,   0xe8ae,   
    0xe9d9,   0x38d4,   0x9b5d,   0xdf3c,   
    0x4249,   0x3963,   0x429f,   0x2c35,   
    0x0325,   0xdd70,   0x3ded,   0xdc5e,   
    0x5b42,   0x12bf,   0xd78c,   0xb26b,   
    0x1b9a,   0x8146,   0x8ec5,   0xc28f,   
    0x5c0f,   0x101c,   0xb082,   0x29e1,   
    0x43de,   0x99fc,   0xbc4b,   0x15dd,   
    0x03fa,   0xb2de,   0x3342,   0xe7c3,   
    0x07ef,   0xebab,   0x859b,   0x2e2f,   
    0x71da,   0x269a,   0xc3d1,   0x6b36,   
    0xdef2,   0xfc5f,   0xb3a3,   0x6ddf,   
    0xb510,   0x85a7,   0x2e71,   0x8816,   
    0x1e2a,   0xf6af,   0xc2b3,   0xf55d,   
    0x6214,   0x83e3,   0xa6f5,   0x41af,   
    0x1f17,   0x99ee,   0x5ec0,   0x16c6,   
    0x09a4,   0x6e01,   0x80d9,   0x1418,   
    0xf227,   0x8203,   0x9d96,   0xa8c0,   
    0xbf6e,   0x7888,   0xfe64,   0x93cd,   
    0x0184,   0x4930,   0x4f36,   0x7088,   
    0x6c2a,   0xc678,   0x4de7,   0xe759,   
    0x248e,   0x446b,   0x9fc2,   0xa895,   
    0xc3a1,   0xf170,   0x9155,   0x8a66,   
    0x5e69,   0x623e,   0xfa35,   0x68cc,   
    0x6acd,   0xe936,   0x2db9,   0x13c1,   
    0xb16d,   0xb83c,   0x3763,   0xa911,   
    0xbc13,   0x79d7,   0x2fa8,   0x196e,   
    0x5476,   0xa866,   0x16ad,   0xc515,   
    0xeb3c,   0xa306,   0x99d9,   0x9133,   
    0x66dd,   0x5dcd,   0x8f50,   0xb226,   
    0xcef3,   0x6189,   0x19b1,   0x3084,   
    0xed5c,   0xc58f,   0xe421,   0x47fb,   
    0x715e,   0xff99,   0x2f0f,   0x5184,   
    0x5e6c,   0x18bc,   0xc6e0,   0xe420,   
    0x523f,   0xb8a2,   0x1a6b,   0x8c02,   
    0xe354,   0x7d79,   0x7753,   0x9655,   
    0x9da1,   0x90a7,   0xc149,   0x7f1c,   
    0x9b69,   0xf2b7,   0x58fa,   0x4418,   
    0x8c76,   0xd9f0,   0x0d4d,   0xc473,   
    0x10e9,   0x4211,   0x082b,   0x334a,   
    0x8ed2,   0xcc1b,   0x0ff3,   0x64a0,   
    0x5a4f,   0xf8e7,   0xf15f,   0xfe21,   
    0x37d6,   0x06f1,   0x0973,   0xde36,   
    0x0fa8,   0xab9e,   0xb618,   0x52f5,   
    0xeb4f,   0xe343,   0x77dd,   0x3da6,   
    0xd52d,   0x12f8,   0x3360,   0x3ad0,   
    0x0f1c,   0xed0b,   0xc1ec,   0x6795,   
    0x9d15,   0x46d7,   0xbe76,   0xe0a0,   
    0x7c02,   0x49b7,   0xd6ba,   0x7f78,   
    0xffbd,   0xca84,   0xf4da,   0x35da,   
    0xaa44,   0x52ac,   0x74a7,   0xa46a,   
    0x152a,   0xb7aa,   0x5927,   0xb118,   
    0x758d,   0x687b,   0xf0b3,   0x54ed,   
    0x7271,   0xacab,   0x4aec,   0x94cd,   
    0x9e81,   0x3730,   0x21e8,   0x7f0b,   
    0xb5d6,   0xadf8,   0x0431,   0xc921,   
    0x5d46,   0x0a36,   0x4022,   0xa65e,   
    0x70ba,   0xa8cc,   0xae8b,   0x24d5,   
    0x8a5a,   0x6b81,   0x2522,   0x1cb8,   
    0xfe1d,   0xc697,   0x4f83,   0x6376,   
    0x224c,   0x3b35,   0xc0fe,   0xa19a,   
    0xb24f,   0xa998,   0x2d71,   0x96a8,   
    0x053f,   0xd300,   0xcbcc,   0x3d40,   
};

/*
 * skipjack ftable
 */
const unsigned char ftable[256] = { 
0xa3,0xd7,0x09,0x83,0xf8,0x48,0xf6,0xf4,0xb3,0x21,0x15,0x78,0x99,0xb1,0xaf,0xf9,
0xe7,0x2d,0x4d,0x8a,0xce,0x4c,0xca,0x2e,0x52,0x95,0xd9,0x1e,0x4e,0x38,0x44,0x28,
0x0a,0xdf,0x02,0xa0,0x17,0xf1,0x60,0x68,0x12,0xb7,0x7a,0xc3,0xe9,0xfa,0x3d,0x53,
0x96,0x84,0x6b,0xba,0xf2,0x63,0x9a,0x19,0x7c,0xae,0xe5,0xf5,0xf7,0x16,0x6a,0xa2,
0x39,0xb6,0x7b,0x0f,0xc1,0x93,0x81,0x1b,0xee,0xb4,0x1a,0xea,0xd0,0x91,0x2f,0xb8,
0x55,0xb9,0xda,0x85,0x3f,0x41,0xbf,0xe0,0x5a,0x58,0x80,0x5f,0x66,0x0b,0xd8,0x90,
0x35,0xd5,0xc0,0xa7,0x33,0x06,0x65,0x69,0x45,0x00,0x94,0x56,0x6d,0x98,0x9b,0x76,
0x97,0xfc,0xb2,0xc2,0xb0,0xfe,0xdb,0x20,0xe1,0xeb,0xd6,0xe4,0xdd,0x47,0x4a,0x1d,
0x42,0xed,0x9e,0x6e,0x49,0x3c,0xcd,0x43,0x27,0xd2,0x07,0xd4,0xde,0xc7,0x67,0x18,
0x89,0xcb,0x30,0x1f,0x8d,0xc6,0x8f,0xaa,0xc8,0x74,0xdc,0xc9,0x5d,0x5c,0x31,0xa4,
0x70,0x88,0x61,0x2c,0x9f,0x0d,0x2b,0x87,0x50,0x82,0x54,0x64,0x26,0x7d,0x03,0x40,
0x34,0x4b,0x1c,0x73,0xd1,0xc4,0xfd,0x3b,0xcc,0xfb,0x7f,0xab,0xe6,0x3e,0x5b,0xa5,
0xad,0x04,0x23,0x9c,0x14,0x51,0x22,0xf0,0x29,0x79,0x71,0x7e,0xff,0x8c,0x0e,0xe2,
0x0c,0xef,0xbc,0x72,0x75,0x6f,0x37,0xa1,0xec,0xd3,0x8e,0x62,0x8b,0x86,0x10,0xe8,
0x08,0x77,0x11,0xbe,0x92,0x4f,0x24,0xc5,0x32,0x36,0x9d,0xcf,0xf3,0xa6,0xbb,0xac,
0x5e,0x6c,0xa9,0x13,0x57,0x25,0xb5,0xe3,0xbd,0xa8,0x3a,0x01,0x05,0x59,0x2a,0x46
};
